# MatCreateSeqBAIJ

Creates a sparse matrix in block AIJ (block compressed row) format. For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased by more than a factor of 50.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode PETSCMAT_DLLEXPORT MatCreateSeqBAIJ(MPI_Comm comm,PetscInt bs,PetscInt m,PetscInt n,PetscInt nz,const PetscInt nnz[],Mat *A)

Collective on MPI_Comm

### Input Parameters

| comm | - MPI communicator, set to PETSC_COMM_SELF
| bs | - size of block
| m | - number of rows
| n | - number of columns
| nz | - number of nonzero blocks per block row (same for all rows)
| nnz | - array containing the number of nonzero blocks in the various block rows (possibly different for each block row) or PETSC_NULL

### Output Parameter

A -the matrix

### Options Database Keys

-mat_no_unroll -uses code that does not unroll the loops in the block calculations (much slower)
-mat_block_size -size of the blocks to use

### C++ variants

| MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,Mat *A) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,0,PETSC_NULL,A)
| MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,const PetscInt nnz[],Mat *A) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,0,nnz,A)
| MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,PetscInt nz,Mat *A) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,nz,PETSC_NULL,A)
| Mat MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,0,PETSC_NULL,&A); return A;
| Mat MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,const PetscInt nnz[]) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,0,nnz,&A); return A;
| Mat MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,PetscInt nz) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,nz,PETSC_NULL,&A); return A;
| Mat MatCreateSeqBAIJ(PetscInt bs,PetscInt m,PetscInt n,PetscInt nz,const PetscInt nnz[]) |  | -> |  | MatCreateSeqBAIJ(PETSC_COMM_SELF,bs,m,n,nz,nnz,&A); return A;

### Notes

The number of rows and columns must be divisible by blocksize.

If the nnz parameter is given then the nz parameter is ignored

A nonzero block is any block that as 1 or more nonzeros in it

The block AIJ format is fully compatible with standard Fortran 77 storage. That is, the stored row and column indices can begin at either one (as in Fortran) or zero. See the users' manual for details.

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=PETSC_NULL for PETSc to control dynamic memory allocation. For additional details, see the users manual chapter on matrices.

### See Also

MatCreate(), MatCreateSeqAIJ(), MatSetValues(), MatCreateMPIBAIJ()

Level:intermediate
Location:src/mat/impls/baij/seq/baij.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/mat/examples/tutorials/ex6.c.html